
#define LCD_ADDR 0x4E     // PCF8574 on pigboard YwRobot back located  on LCD4x20
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01

// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1
#define LCD_LINE3 0x94      // 0x14 + bit D7=1
#define LCD_LINE4 0xD4      // 0x54 + bit D7=1









extern const code char mesg0[]="                   ";
extern  int status;
extern unsigned char * txt;
extern unsigned int addr;

extern void strConstRamCpy(unsigned char *dest, const code char *source);
extern void CRLF(void) ;

unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
void LCD_init_4x20(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_puts(char *s);
void LCD_putsRom(code char *s);

//fonctions LCD derives
//void Affiche_Time(int ModeOutput);
void LCD_Msg_Status(const char* T);  // affiche un TEXTE en ligne 4
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c);